/* A simple test for threads */

#include <boost/thread/thread.hpp>
#include <boost/thread/xtime.hpp>
#include <iostream>
#include <string>

struct thread_action {
	int delay;
	std::string message;
	thread_action(int delay_secs, std::string msg)
		: delay(delay_secs), message(msg) {}
	void operator()() {
		boost::xtime xt;
		boost::xtime_get(&xt, boost::TIME_UTC);
		xt.sec += delay;
		boost::thread::sleep(xt);
		std::cout << message << std::endl;
	}
};

int main(int argc, char* argv[]) {
	std::cout << "Starting up new threads..." << std::endl;
	boost::thread t1(thread_action(1, "Message 1"));
	t1.join();
	boost::thread_group ts;
	for(int i = 0; i < 10; i++)
		ts.create_thread(thread_action(i, "Message"));
	ts.join_all();
}

